import Text = Phaser.GameObjects.Text;
import { BaseButton } from './baseButton';
import TextStyle = Phaser.Types.GameObjects.Text.TextStyle;

export class Button extends BaseButton {
  text: Text;
  activeOffset;

  constructor(scene, x, y, width, height, text, frame, textStyle: TextStyle = {}, callback = () => {}, repeatingFire = false) {
    super(scene, x, y, width, height, frame, callback, repeatingFire);

    const fontSize = Math.floor(this.buttonHeight / 2) + 'px';
    const style = {fontSize, color: 'black', fontFamily: '"Architects Daughter"', ...textStyle};
    this.text = new Text(scene, 0, 0, text, style).setOrigin(0.5);

    this.activeOffset = Math.floor(height / 16);
    this.add([this.button, this.text]);
    this.isShowed = true;
  }

  enterButtonNormalState() {
    super.enterButtonNormalState();
    this.text.setY(0);
  }

  enterButtonActiveState() {
    super.enterButtonActiveState();
    this.text.setY(this.activeOffset);
  }

  setText(text) {
    this.text.setText(text);
  }
}
