import Image = Phaser.GameObjects.Image;

export class Panel extends Phaser.GameObjects.Container {
  top: number;
  bottom: number;
  left: number;
  right: number;
  frame: string;

  image: Image;

  constructor(scene, x, y, width, height, frame = 'panelInset_beigeLight') {
    super(scene, x, y);

    this.frame = frame;
    this.width = width;
    this.height = height;
    this.top = Math.ceil(-this.height / 2);
    this.bottom = Math.ceil(this.height / 2);
    this.left = Math.ceil(-this.width / 2);
    this.right = Math.ceil(this.width / 2);

    this.image = new Image(scene, 0, 0, 'ui', this.frame + '.png');
    this.image.setDisplaySize(width, height);
  }
}
