import Text = Phaser.GameObjects.Text;
import BaseLevelScene from './baseLevel.scene';
import { Button } from '../components';
import { gameConfig } from '../config';

export default class IntroScene extends BaseLevelScene {

  playButton: Button;
  text: Text;

  constructor() {
    super({key: 'IntroScene'})
  }

  create() {
    super.create();
    this.fadeIn(500);
    this.getWorldView();

    this.text = this.add.text(this.view.centerX - 300, this.view.top + 50, [
      "You wake up after a party",
      "and cannot remember a single",
      "recipe, and customers are",
      "at your doorstep.",
      "You have to quickly bring",
      "service to everyone.",
      "",
      "Combine ingredients to reach",
      "success!",
      "",
      "$ - sell",
      "X - restart poison",
      "< - skip a client",
    ], {fontSize: '42px', fontFamily: '"Architects Daughter"', color: 'black'});

    this.playButton = new Button(this, this.view.centerX, this.view.bottom - 100, 400, 112, gameConfig.lang.play, 'buttonLong_grey', {}, () => {
      this.startGame()
    });
    this.add.existing(this.playButton);
  }

  update(time, delta) {
    super.update(time, delta);
    this.children.each(i => i.update(time, delta));
  }


  startGame() {

    this.fadeOutScene('GameScene', 750);
  }
}
