import Text = Phaser.GameObjects.Text;
import BaseScene from './base.scene';
import { Button } from '../components';
import { gameConfig, gameStat } from '../config';
import { usageController } from '../controllers';

export default class MainMenuScene extends BaseScene {

  playButton: Button;
  label: Text;

  constructor() {
    super({ key: 'MainMenuScene' });
  }

  create() {
    super.create();
    //this.fadeIn(200);
    this.getWorldView();

    const buttons: any[] = [];
    this.playButton = new Button(this, 0, 0, 400, 112, gameConfig.lang.play, 'buttonLong_grey', {}, () => {
      this.startGame()
    });
    this.playButton.setAlpha(0);
    this.fixedContainers.push(this.playButton);
    this.add.existing(this.playButton);
    buttons.push(this.playButton);

    this.label = new Text(this, 0, 0, 'Forgetful\nAlchemist', {fontSize: '64px', color: 'black', fontFamily: '"Architects Daughter"'});
    this.label.setOrigin(0.5).setAlpha(0);
    buttons.push(this.label);
    this.add.existing(this.label);

    this.onResize();

    this.time.addEvent({
      delay: 750,
      callback: () => {
        this.tweens.add({
          targets: buttons,
          alpha: 1,
          duration: 500,
        });
      }
    });
    usageController.log('start');
  }

  onResize() {
    super.onResize();
    this.label.setPosition(this.view.centerX, this.view.centerY - 260);
    this.playButton.setPosition(this.view.centerX, this.view.centerY + 260);
  }


  update() {

  }


  startGame() {
    if (gameStat.tutorialFinished) {
      this.fadeOutScene('GameScene', 750);
    } else {
      this.fadeOutScene('IntroScene', 750);
    }
  }
}
