import Sprite = Phaser.GameObjects.Sprite;
import BaseLevelScene from '../scenes/baseLevel.scene';

const waveAngle = 15;
const waveStep = 1.5;

export default class ClientSprite extends Sprite{
  type: string;
  scene: BaseLevelScene;
  waveDir = 1;

  constructor(scene, type) {
    super(scene, 0, 0, 'clients', type + '.png');
    this.setOrigin(0.5, 0.5);
    this.type = type;
    this.scene = scene;
  }

  update(time, delta) {
    super.update(time, delta);
  }

  walkTween(x, duration, callback = () => {}) {
    this.scene.tweens.add({
      targets: this,
      x,
      onUpdate: () => {
        if (this.angle > waveAngle) {
          this.waveDir = -1;
        } else if (this.angle < -waveAngle) {
          this.waveDir = 1;
        }
        this.setAngle(this.angle + waveStep * this.waveDir);
      },
      onComplete: () => {
        this.scene.tweens.add({
          targets: this,
          angle: 0,
          duration: 100,
        })
        callback();
      },
      duration,
    });
  }

  setType(type) {
    this.type = type;
    this.setFrame(type + '.png');
    return this;
  }
}
