import Sprite = Phaser.GameObjects.Sprite;
import BaseLevelScene from '../scenes/baseLevel.scene';


export default class EffectSprite extends Sprite{
  type: string;
  scene: BaseLevelScene;

  constructor(scene, type) {
    super(scene, 0, 0, 'effects', type + '.png');
    this.type = type;
    this.scene = scene;
    this.setDisplaySize(64, 64).setOrigin(0, 0.5);
  }

  setType(type) {
    this.type = type;
    this.setFrame(type + '.png');
    return this;
  }
}
